sap.ui.jsview("sas.fscf.views.RelatedRows", {

	getControllerName: function() {
		return "sas.fscf.views.RelatedRows";
	},
	
    _bExplore: false,
    
    isExplore: function() {
    	return this._bExplore;
    },
    
    setExplore: function(bExplore) {
    	this._bExplore = bExplore;
    },

	_fields: [],
	_alertTypes: [],

	createContent: function(oController) {		
	},
	
	lazyLoadContent: function(oController) {
      if (this.getContent().length == 0) {
		jQuery.sap.require("sas.hc.ui.table.Table");
		jQuery.sap.require("sas.hc.ui.table.Column");
		jQuery.sap.require("sap.ui.model.json.JSONModel");
    	jQuery.sap.require("sas.hc.ui.unified.Menu");
        jQuery.sap.require("sas.hc.ui.unified.MenuItem");

		var _this = this;
		
    	this.addStyleClass("cfRelatedRowsView");    	

		var model = new sap.ui.model.json.JSONModel({});

		var table = new sas.hc.ui.table.Table({
			id: this.sId + '_TransactionTable', 
			editable: true,
			visibleRowCountMode: sap.ui.table.VisibleRowCountMode.Auto
		});

		table.setModel(model);
		table.bindRows("/items");
		table.attachBeforeColumnsDialogClose(function(oEvent) {
			if (oEvent.mParameters.acceptedChange) {
				_this._fields = [];
				oEvent.oSource.getColumns().forEach(function(col) {
					if (col.getVisible()) {
						_this._fields[_this._fields.length] = col.getSortProperty();
					}
				});
				_this.update();
				if (!sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties) {
					sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties = {};
				}
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultRelatedRowsColumns = _this._fields.join(" ");
				sas.fscf.getCurrentPageView().setDirty(true);				
			}
		});
		table.attachColumnMove(function(oEvent) {
			var i = $.inArray(oEvent.mParameters.column.getSortProperty(), _this._fields);
			if (i !== -1) {
				_this._fields.splice(i, 1); // remove the field
				_this._fields.splice(oEvent.mParameters.newPos, 0, oEvent.mParameters.column.getSortProperty()); // add it back in the new position
				if (!sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties) {
					sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties = {};
				}
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultRelatedRowsColumns = _this._fields.join(" ");
				sas.fscf.getCurrentPageView().setDirty(true);				
			}
		});
		
		if (this.isExplore()) {
	    	sas.ajax({url:'rest/alerttypes'})
			  .done(function(oData){ 
				  _this._alertTypes = oData.items;
			}).fail(function(oObj,textStatus){			
		         console.info("Failed to get alert types.");
			});			
			
			var oMenu = new sas.hc.ui.unified.Menu(table.sId + "_Menu");
			// set name attribute
	    	oMenu.onAfterRendering = function() {
	        	if (sas.hc.ui.unified.Menu.prototype.onAfterRendering) {
	        		sas.hc.ui.unified.Menu.prototype.onAfterRendering.apply(this);
	        	}
	        	// must be set after rendering when the dom ref will exist
	        	this.getDomRef().setAttribute("name", "Menu");
	    	};
	        table.setAggregation("contextMenu", oMenu);
	        table.attachCellContextmenu(function(oEvent) {
				_this._contextField = oEvent.oSource.getColumns()[parseInt(oEvent.mParameters.columnIndex)].getSortProperty();
				_this._contextAlertType = _this.getAlertTypeForField(_this._contextField);
				
				// table could be scrolled down, so factor in first visible row
				var row = oEvent.oSource.getRows()[oEvent.mParameters.rowIndex - oEvent.oSource.getFirstVisibleRow()];
				if (row) {
					_this._contextValue = row.getCells()[parseInt(oEvent.mParameters.columnIndex)].getText();
				} else {
					_this._contextValue = "";
				}
				if (row) {
					var rowData = row.getModel().getData().items[row.getIndex()];
					if (rowData) {
						_this._contextTxnId = "" + rowData["CMX_TRAN_ID"];
						_this._contextTxnAcronym = rowData["SMH_ACCT_TYPE"] + rowData["SMH_ACTIVITY_TYPE"]; 
					} else {
						_this._contextTxnId = "";
						_this._contextTxnAcronym = ""; 
					}
				} else {
					_this._contextTxnId = "";
					_this._contextTxnAcronym = ""; 
				}
				var bEnabled = table.getModel().getData() && (table.getModel().getData().count > 0) && (_this._contextTxnId.length > 0);
       		    oMenuItem.setEnabled(bEnabled);
       		    oMenuItemAddToList.setEnabled(bEnabled);
       		    oMenuItemRemoveFromList.setEnabled(bEnabled);
       		});

	        var oMenuItem = new sas.hc.ui.unified.MenuItem({
	        	id: table.sId + "_CreateAlertMenuItem",
	            text: sas.fscf.rb.getText("rules.rulesPage.guidedView.form.actions.CreateAnAlert.txt"),
	            enabled: false
	        });
	        oMenuItem.attachSelect(function(oEvent) {
	        	_this.getActionConfiguration().open();
	        });
			// set name attribute
	    	oMenuItem.onAfterRendering = function() {
	        	if (sas.hc.ui.unified.MenuItem.prototype.onAfterRendering) {
	        		sas.hc.ui.unified.MenuItem.prototype.onAfterRendering.apply(this);
	        	}
	        	// must be set after rendering when the dom ref will exist
	        	this.getDomRef().setAttribute("name", "CreateAlertMenuItem");
	    	};
	        oMenu.addItem(oMenuItem);

	        var oMenuItemAddToList = new sas.hc.ui.unified.MenuItem({
	        	id: table.sId + "_AddToListMenuItem",
	            text: sas.fscf.rb.getText("rules.rulesPage.guidedView.relatedRows.actions.AddToList.txt"),
	            enabled: false,
                startsSection: true
	        });
	        oMenuItemAddToList.attachSelect(function(oEvent) {
	        	_this.getAnalystListDialog(true).open();
	        });
			// set name attribute
	        oMenuItemAddToList.onAfterRendering = function() {
	        	if (sas.hc.ui.unified.MenuItem.prototype.onAfterRendering) {
	        		sas.hc.ui.unified.MenuItem.prototype.onAfterRendering.apply(this);
	        	}
	        	// must be set after rendering when the dom ref will exist
	        	this.getDomRef().setAttribute("name", "AddToListMenuItem");
	    	};
	        oMenu.addItem(oMenuItemAddToList);

	        var oMenuItemRemoveFromList = new sas.hc.ui.unified.MenuItem({
	        	id: table.sId + "_RemoveFromListMenuItem",
	            text: sas.fscf.rb.getText("rules.rulesPage.guidedView.relatedRows.actions.RemoveFromList.txt"),
	            enabled: false
	        });
	        oMenuItemRemoveFromList.attachSelect(function(oEvent) {
	        	_this.getAnalystListDialog(false).open();
	        });
			// set name attribute
	        oMenuItemRemoveFromList.onAfterRendering = function() {
	        	if (sas.hc.ui.unified.MenuItem.prototype.onAfterRendering) {
	        		sas.hc.ui.unified.MenuItem.prototype.onAfterRendering.apply(this);
	        	}
	        	// must be set after rendering when the dom ref will exist
	        	this.getDomRef().setAttribute("name", "RemoveFromListMenuItem");
	    	};
	        oMenu.addItem(oMenuItemRemoveFromList);
		}
		
        this.addContent(table);
        
        if (this.isExplore()) {
        	setTimeout(function() {
            	_this.update();
        	}, 1000);
        }
      }
	},
	
	update: function() {
		// do nothing if the Related Rows tab is not the current tab
		if (sas.fscf.getCurrentPageView().getGuidedView().getCurrentTab &&
			sas.fscf.getCurrentPageView().getGuidedView().getCurrentTab().indexOf("RelatedRowsTab") == -1) {
			//console.info("Related Rows not current tab; did not update");
			return;
		}
		
		//console.info("updating Related Rows");
		var _this = this;
		this.setBusy(true);

		var table = sap.ui.getCore().byId(_this.sId + '_TransactionTable');
	  	  
		// add the columns if they have not already been added
		if (table.getColumns().length == 0) {
			var defaultRelatedRowsColumns;
			if (this.isExplore()) {
				defaultRelatedRowsColumns = sas.config.get('fscf').exploreDefaultRelatedRowsColumns;
			} else {
				defaultRelatedRowsColumns = sas.config.get('fscf').defaultRelatedRowsColumns;
			}
			if (sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties && 
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultRelatedRowsColumns && 
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultRelatedRowsColumns.length > 0) {
				defaultRelatedRowsColumns = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultRelatedRowsColumns;
			} 
			if (defaultRelatedRowsColumns) {
				// add the initially visible columns
				this._fields = defaultRelatedRowsColumns.split(" ");
				for (var i = 0; i < this._fields.length; i++) {
					table.addColumn(
							new sas.hc.ui.table.Column({
								label: new sas.hc.m.Label({
									text: this._fields[i]
								}),
								template: new sas.hc.m.Text({
									text: "{" + this._fields[i] + "}"
								}),
								sortProperty: this._fields[i],
								visible: true,
								width: "200px"//(this._fields[i].length * 16) + "px"
							})
					);
				}
			}
			
			var palette = this.getPalette();
			if (palette._model.getData().items) {
				// add the initially not-visible columns
				for (var i = 0; i < palette._model.getData().items.length; i++) {
					if ($.inArray(palette._model.getData().items[i].altName, this._fields) === -1) {
						table.addColumn(
								new sas.hc.ui.table.Column({
									label: new sas.hc.m.Label({
										text: palette._model.getData().items[i].altName
									}),
									template: new sas.hc.m.Text({
										text: "{" + palette._model.getData().items[i].altName + "}"
									}),
									sortProperty: palette._model.getData().items[i].altName,
									visible: false,
									width: "200px"//(palette._model.getData().items[i].altName.length * 16) + "px"
								})
						);
					}
				}
			}
		}
	  
		// update the rows and re-bind the data model
		var schema = null;
		if (_this.isExplore()) {
			schema = "esdb";
		}
        $.ajax({url:sas.fscf.getQueryUrlFromRuleModel("search", schema, _this.padFields(_this._fields)), contentType:"application/json; charset=utf-8", dataType:"json"})
          .done(function(oData){
        	  table.getModel().setData(oData);
  			  _this.setBusy(false);
        }).fail(function(oObj,textStatus){
        	console.info("an error occurred getting the related rows");
			_this.setBusy(false);
        });
	},
    
    padFields: function(fields) {
    	if (this.isExplore()) {
    		// make sure CMX_TRAN_ID, SMH_ACCT_TYPE & SMH_ACTIVITY_TYPE are always in fields, 
    		// as their values are needed to determine _contextTxnId & _contextTxnAcronym for Create an Alert
    		var newArray = fields.slice(0); // clone the array
    		if ($.inArray("CMX_TRAN_ID", newArray) === -1) {
    			newArray[newArray.length] = "CMX_TRAN_ID";
    		} 		
    		if ($.inArray("SMH_ACCT_TYPE", newArray) === -1) {
    			newArray[newArray.length] = "SMH_ACCT_TYPE";
    		} 		
    		if ($.inArray("SMH_ACTIVITY_TYPE", newArray) === -1) {
    			newArray[newArray.length] = "SMH_ACTIVITY_TYPE";
    		} 		
        	return newArray;
    	}
    	return fields;
    },
	
	getAlertTypeForField: function(fieldName) {
		for (var i = 0; i < this._alertTypes.length; i++) {
			if (this._alertTypes[i].AlertableEntityField.toLowerCase() == fieldName.toLowerCase()) {
				return this._alertTypes[i];
			}
		}
		return null;
	},
	
    getPalette: function() {
    	return sap.ui.getCore().byId(this.sId.substr(0, this.sId.indexOf("RelatedRowsView")) + "PaletteView");
    },
    
    getActionConfiguration: function(){
    	var view = sap.ui.jsfragment({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "AlertCreationConfigurationDialog",
            fragmentName: "sas.fscf.views.fragments.AlertCreationConfigurationDialog"
        });
    	view.setExplore(true);
    	view.setExploreContext({"txnId":this._contextTxnId, "txnAcronym":this._contextTxnAcronym, "fieldName":this._contextField, "fieldValue":this._contextValue, "alertType":this._contextAlertType});
    	return view.lazyLoadContent();
    },    
    
    getAnalystListDialog: function(bAdd){
    	var view = sap.ui.jsfragment({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "AnalystListDialog",
            fragmentName: "sas.fscf.views.fragments.AnalystListDialog"
        });
    	view.setAdd(bAdd);
    	view.setExplore(true);
    	view.setExploreContext({"txnId":this._contextTxnId, "txnAcronym":this._contextTxnAcronym, "fieldName":this._contextField, "fieldValue":this._contextValue, "alertType":this._contextAlertType});
    	return view.lazyLoadContent();
    }    
});